<mat-sidenav-container autosize class="maarch-container">
    <ng-template #adminMenuTemplate>
        <mat-nav-list>
            <h3 mat-subheader>{{lang.actions}}</h3>
            <a mat-list-item routerLink="/administration/notifications/new">
                <mat-icon color="primary" mat-list-icon class="fa fa-plus"></mat-icon>
                <p mat-line>
                    {{lang.add}}
                </p>
            </a>
            <a mat-list-item (click)="loadCron();snav2.toggle();">
                <mat-icon color="primary" mat-list-icon class="fa fa-clock"></mat-icon>
                <p mat-line>
                    {{lang.toSchedule}}
                </p>
            </a>
        </mat-nav-list>
    </ng-template>
    <mat-sidenav-content>
        <div class="bg-head">
            <div class="bg-head-title" [class.customContainerRight]="appService.getViewMode()">
                <div class="bg-head-title-label">
                    <header-left></header-left>
                </div>
                <div class="bg-head-title-tool">
                    <header-right></header-right>
                </div>
            </div>
            <div class="bg-head-content" [class.fullContainer]="appService.getViewMode()">
            </div>
        </div>
        <div class="container" [class.fullContainer]="appService.getViewMode()">
            <div class="container-content">
                <div *ngIf="loading" style="display:flex;height:100%;">
                    <mat-spinner style="margin:auto;"></mat-spinner>
                </div>
                <mat-card *ngIf="!loading" class="card-app-content">
                    <div class="row">
                        <div class="col-md-6 col-xs-6">
                            <mat-form-field>
                                <input matInput (keyup)="applyFilter($event.target.value)"
                                    placeholder="{{lang.filterBy}}">
                            </mat-form-field>
                        </div>
                        <div class="col-md-6 col-xs-6">
                            <mat-paginator #paginator [length]="100" [hidePageSize]="true" [pageSize]="10">
                            </mat-paginator>
                        </div>
                    </div>
                    <mat-table #table [dataSource]="dataSource" matSort matSortActive="notification_id"
                        matSortDirection="asc">
                        <ng-container matColumnDef="notification_id">
                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:1;"
                                [class.hide-for-mobile]="appService.getViewMode()">{{lang.id}}</mat-header-cell>
                            <mat-cell *matCellDef="let element" style="flex:1;"
                                [class.hide-for-mobile]="appService.getViewMode()"> {{element.notification_id}}
                            </mat-cell>
                        </ng-container>
                        <ng-container matColumnDef="description">
                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:2;">{{lang.description}}
                            </mat-header-cell>
                            <mat-cell *matCellDef="let element" style="flex:2;"> {{element.description}} </mat-cell>
                        </ng-container>
                        <ng-container matColumnDef="is_enabled">
                            <mat-header-cell *matHeaderCellDef mat-sort-header style="flex:1;"
                                [class.hide-for-mobile]="appService.getViewMode()">{{lang.status}}</mat-header-cell>
                            <mat-cell *matCellDef="let element" matTooltip="{{lang.view}}" style="flex:1;"
                                [class.hide-for-mobile]="appService.getViewMode()">
                                <span *ngIf="element.is_enabled == 'Y'" color="primary"
                                    class="label">{{lang.active}}</span>
                                <span *ngIf="element.is_enabled == 'N'" color="warn"
                                    class="label">{{lang.suspended}}</span>
                            </mat-cell>
                        </ng-container>
                        <ng-container matColumnDef="notifications">
                            <mat-header-cell *matHeaderCellDef style="flex:1;"></mat-header-cell>
                            <mat-cell *matCellDef="let element" style="justify-content: flex-end;flex:1;">
                                <button mat-icon-button color="warn" matTooltip="{{lang.delete}}"
                                    (click)="$event.stopPropagation();deleteNotification(element)">
                                    <mat-icon class="fa fa-trash-alt fa-2x" aria-hidden="true"></mat-icon>
                                </button>
                            </mat-cell>
                        </ng-container>
                        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
                        <mat-row *matRowDef="let row; columns: displayedColumns;"
                            routerLink="/administration/notifications/{{row.notification_sid}}" style="cursor:pointer;"
                            matTooltip="{{lang.view}}"></mat-row>
                    </mat-table>
                    <div class="mat-paginator"
                        style="min-height:48px;min-height: 48px;display: flex;justify-content: end;align-items: center;padding-right: 20px;">
                        {{notifications.length}} {{lang.notifications}}</div>
                </mat-card>
            </div>
        </div>
    </mat-sidenav-content>
    <mat-sidenav #snav2 [mode]="appService.getViewMode() ? 'over' : 'side'" [fixedInViewport]="appService.getViewMode()"
        fixedTopGap="56" position='end' [opened]="appService.getViewMode() ? false : false">
        <mat-list>
            <h3 mat-subheader>{{lang.notificationSchedule}}</h3>
            <form class="form-horizontal" #notifForm="ngForm" style="overflow:hidden;">
                <div class="form-group" style="padding-left:15px;padding-right:15px;">
                    <div class="col-sm-4">
                        <mat-form-field>
                            <mat-select name="hour" id="hour" title="{{lang.hour}}" placeholder="{{lang.hour}}"
                                [(ngModel)]="newCron.h" required>
                                <mat-option *ngFor="let hour of hours" [value]="hour.value">
                                    {{hour.label}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="col-sm-4">
                        <mat-form-field>
                            <mat-select name="minute" id="minute" title="{{lang.minute}}" placeholder="{{lang.minute}}"
                                [(ngModel)]="newCron.m" required>
                                <mat-option *ngFor="let minute of minutes" [value]="minute.value">
                                    {{minute.label}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="col-sm-4">
                        <mat-form-field>
                            <mat-select name="day" id="day" title="{{lang.day}}" placeholder="{{lang.day}}"
                                [(ngModel)]="newCron.dow" required>
                                <mat-option *ngFor="let day of dow" [value]="day.value">
                                    {{day.label}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                </div>
                <div class="form-group" style="padding-left:15px;padding-right:15px;">
                    <div class="col-sm-6">
                        <mat-form-field>
                            <mat-select name="month" id="month" title="{{lang.month}}" placeholder="{{lang.month}}"
                                [(ngModel)]="newCron.mon" required>
                                <mat-option *ngFor="let month of months" [value]="month.value">
                                    {{month.label}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="col-sm-6">
                        <mat-form-field>
                            <mat-select name="dayM" id="dayM" title="{{lang.dayOfMonth}}"
                                placeholder="{{lang.dayOfMonth}}" [(ngModel)]="newCron.dom" required>
                                <mat-option *ngFor="let dayM of dom" [value]="dayM.value">
                                    {{dayM.label}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="col-sm-12">
                        <mat-form-field>
                            <mat-select name="script" id="script" title="{{lang.script}}" placeholder="{{lang.script}}"
                                [(ngModel)]="newCron.cmd" required>
                                <mat-option *ngFor="let notif of authorizedNotification" [value]="notif.path">
                                    {{notif.description}}
                                </mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="col-sm-12 text-center" style="padding:10px;">
                        <button mat-raised-button [disabled]="!notifForm.form.valid" color="primary"
                            (click)="saveCron()">{{lang.save}}</button>
                    </div>
                </div>
            </form>
        </mat-list>
        <mat-divider></mat-divider>
        <div class="alert alert-info" role="alert" style="margin:15px;">
            {{lang.NotificationScheduleInfo}}
        </div>
        <mat-list>
            <h3 mat-subheader>{{lang.activeCron}}</h3>
            <mat-chip-list #chipList class="mat-chip-list-stacked">
                <span *ngFor="let notif of crontab;let i = index">
                    <mat-chip color="primary" *ngIf="notif.state == 'normal'"
                        style="margin:5px;border-radius:0px;display:flex;" selectable="false" removable="true"
                        (removed)="deleteCron(i)">
                        {{notif.description}}
                        <span style="flex: 1 1 auto;"></span>
                        <b>{{notif.m}}&nbsp;&nbsp;{{notif.h}}&nbsp;&nbsp;{{notif.dom}}&nbsp;&nbsp;{{notif.mon}}&nbsp;&nbsp;{{notif.dow}}</b>
                        <mat-icon matTooltip="{{lang.delete}}" matChipRemove color="warn" class="fa fa-times">
                        </mat-icon>
                    </mat-chip>
                </span>
            </mat-chip-list>
        </mat-list>
    </mat-sidenav>
</mat-sidenav-container>